/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package gov.anl.aps.dm.portal.model.entities;

import java.util.List;
import javax.persistence.Basic;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.OneToMany;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;

/**
 *
 * @author sveseli
 */
@Entity
@Table(name = "template_policy_set")
@XmlRootElement
@NamedQueries({
    @NamedQuery(name = "TemplatePolicySet.findAll", query = "SELECT t FROM TemplatePolicySet t"),
    @NamedQuery(name = "TemplatePolicySet.findById", query = "SELECT t FROM TemplatePolicySet t WHERE t.id = :id"),
    @NamedQuery(name = "TemplatePolicySet.findByName", query = "SELECT t FROM TemplatePolicySet t WHERE t.name = :name"),
    @NamedQuery(name = "TemplatePolicySet.findByDescription", query = "SELECT t FROM TemplatePolicySet t WHERE t.description = :description")})
public class TemplatePolicySet extends CloneableEntity
{
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Basic(optional = false)
    @Column(name = "id")
    private Integer id;
    @Basic(optional = false)
    @NotNull
    @Size(min = 1, max = 2147483647)
    @Column(name = "name")
    private String name;
    @Size(max = 2147483647)
    @Column(name = "description")
    private String description;
    @OneToMany(cascade = CascadeType.ALL, mappedBy = "templatePolicySet")
    private List<TemplatePolicy> templatePolicyList;

    public TemplatePolicySet() {
    }

    public TemplatePolicySet(Integer id) {
        this.id = id;
    }

    public TemplatePolicySet(Integer id, String name) {
        this.id = id;
        this.name = name;
    }

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    @XmlTransient
    public List<TemplatePolicy> getTemplatePolicyList() {
        return templatePolicyList;
    }

    public void setTemplatePolicyList(List<TemplatePolicy> templatePolicyList) {
        this.templatePolicyList = templatePolicyList;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (id != null ? id.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof TemplatePolicySet)) {
            return false;
        }
        TemplatePolicySet other = (TemplatePolicySet) object;
        if ((this.id == null && other.id != null) || (this.id != null && !this.id.equals(other.id))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "gov.anl.aps.dm.portal.model.entities.TemplatePolicySet[ id=" + id + " ]";
    }
    
}
